Errors (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.validation

## Interface Errors

- All Known Subinterfaces:
    BindingResult
  All Known Implementing Classes:
    AbstractBindingResult, AbstractErrors, AbstractPropertyBindingResult, BeanPropertyBindingResult, BindException, DirectFieldBindingResult, EscapedErrors, MapBindingResult

      public interface Errors

  Stores and exposes information about data-binding and validation errors for a specific object.

  Field names can be properties of the target object (e.g. "name" when binding to a customer object), or nested fields in case of subobjects (e.g. "address.street"). Supports subtree navigation via `setNestedPath(String)`: for example, an `AddressValidator` validates "address", not being aware that this is a subobject of customer.

  Note: `Errors` objects are single-threaded.

  Author:
    Rod Johnson, Juergen Hoeller
  See Also:
    `setNestedPath(java.lang.String)`, `BindException`, `DataBinder`, `ValidationUtils`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `NESTED_PATH_SEPARATOR` The separator between path elements in a nested path, for example in "customer.name" or "customer.address.street".

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAllErrors(Errors errors)` Add all errors from the given `Errors` instance to this `Errors` instance.
    `List<ObjectError>` | `getAllErrors()` Get all errors, both global and field ones.
    `int` | `getErrorCount()` Return the total number of errors.
    `FieldError` | `getFieldError()` Get the first error associated with a field, if any.
    `FieldError` | `getFieldError(String field)` Get the first error associated with the given field, if any.
    `int` | `getFieldErrorCount()` Return the number of errors associated with a field.
    `int` | `getFieldErrorCount(String field)` Return the number of errors associated with the given field.
    `List<FieldError>` | `getFieldErrors()` Get all errors associated with a field.
    `List<FieldError>` | `getFieldErrors(String field)` Get all errors associated with the given field.
    `Class<?>` | `getFieldType(String field)` Return the type of a given field.
    `Object` | `getFieldValue(String field)` Return the current value of the given field, either the current bean property value or a rejected update from the last binding.
    `ObjectError` | `getGlobalError()` Get the first global error, if any.
    `int` | `getGlobalErrorCount()` Return the number of global errors.
    `List<ObjectError>` | `getGlobalErrors()` Get all global errors.
    `String` | `getNestedPath()` Return the current nested path of this `Errors` object.
    `String` | `getObjectName()` Return the name of the bound root object.
    `boolean` | `hasErrors()` Return if there were any errors.
    `boolean` | `hasFieldErrors()` Are there any field errors?
    `boolean` | `hasFieldErrors(String field)` Are there any errors associated with the given field?
    `boolean` | `hasGlobalErrors()` Are there any global errors?
    `void` | `popNestedPath()` Pop the former nested path from the nested path stack.
    `void` | `pushNestedPath(String subPath)` Push the given sub path onto the nested path stack.
    `void` | `reject(String errorCode)` Register a global error for the entire target object, using the given error description.
    `void` | `reject(String errorCode, Object[] errorArgs, String defaultMessage)` Register a global error for the entire target object, using the given error description.
    `void` | `reject(String errorCode, String defaultMessage)` Register a global error for the entire target object, using the given error description.
    `void` | `rejectValue(String field, String errorCode)` Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
    `void` | `rejectValue(String field, String errorCode, Object[] errorArgs, String defaultMessage)` Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
    `void` | `rejectValue(String field, String errorCode, String defaultMessage)` Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.
    `void` | `setNestedPath(String nestedPath)` Allow context to be changed so that standard validators can validate subtrees.

- - ### Field Detail

    - #### NESTED_PATH_SEPARATOR

          static final String NESTED_PATH_SEPARATOR

      The separator between path elements in a nested path, for example in "customer.name" or "customer.address.street".

      "." = same as the `nested property separator` in the beans package.

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getObjectName

          String getObjectName()

      Return the name of the bound root object.

    - #### setNestedPath

          void setNestedPath(String nestedPath)

      Allow context to be changed so that standard validators can validate subtrees. Reject calls prepend the given path to the field names.

      For example, an address validator could validate the subobject "address" of a customer object.

      Parameters:
        `nestedPath` - nested path within this object, e.g. "address" (defaults to "", `null` is also acceptable). Can end with a dot: both "address" and "address." are valid.

    - #### getNestedPath

          String getNestedPath()

      Return the current nested path of this `Errors` object.

      Returns a nested path with a dot, i.e. "address.", for easy building of concatenated paths. Default is an empty String.

    - #### pushNestedPath

          void pushNestedPath(String subPath)

      Push the given sub path onto the nested path stack.

      A `popNestedPath()` call will reset the original nested path before the corresponding `pushNestedPath(String)` call.

      Using the nested path stack allows to set temporary nested paths for subobjects without having to worry about a temporary path holder.

      For example: current path "spouse.", pushNestedPath("child") -> result path "spouse.child."; popNestedPath() -> "spouse." again.

      Parameters:
        `subPath` - the sub path to push onto the nested path stack
      See Also:
        `popNestedPath()`

    - #### popNestedPath

          void popNestedPath()
                             throws IllegalStateException

      Pop the former nested path from the nested path stack.
      Throws:
        `IllegalStateException` - if there is no former nested path on the stack
      See Also:
        `pushNestedPath(java.lang.String)`

    - #### reject

          void reject(String errorCode)

      Register a global error for the entire target object, using the given error description.
      Parameters:
        `errorCode` - error code, interpretable as a message key

    - #### reject

          void reject(String errorCode,
                    String defaultMessage)

      Register a global error for the entire target object, using the given error description.
      Parameters:
        `errorCode` - error code, interpretable as a message key
        `defaultMessage` - fallback default message

    - #### reject

          void reject(String errorCode,
                    Object[] errorArgs,
                    String defaultMessage)

      Register a global error for the entire target object, using the given error description.
      Parameters:
        `errorCode` - error code, interpretable as a message key
        `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
        `defaultMessage` - fallback default message

    - #### rejectValue

          void rejectValue(String field,
                         String errorCode)

      Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

      The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

      Parameters:
        `field` - the field name (may be `null` or empty String)
        `errorCode` - error code, interpretable as a message key
      See Also:
        `getNestedPath()`

    - #### rejectValue

          void rejectValue(String field,
                         String errorCode,
                         String defaultMessage)

      Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

      The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

      Parameters:
        `field` - the field name (may be `null` or empty String)
        `errorCode` - error code, interpretable as a message key
        `defaultMessage` - fallback default message
      See Also:
        `getNestedPath()`

    - #### rejectValue

          void rejectValue(String field,
                         String errorCode,
                         Object[] errorArgs,
                         String defaultMessage)

      Register a field error for the specified field of the current object (respecting the current nested path, if any), using the given error description.

      The field name may be `null` or empty String to indicate the current object itself rather than a field of it. This may result in a corresponding field error within the nested object graph or a global error if the current object is the top object.

      Parameters:
        `field` - the field name (may be `null` or empty String)
        `errorCode` - error code, interpretable as a message key
        `errorArgs` - error arguments, for argument binding via MessageFormat (can be `null`)
        `defaultMessage` - fallback default message
      See Also:
        `getNestedPath()`

    - #### addAllErrors

          void addAllErrors(Errors errors)

      Add all errors from the given `Errors` instance to this `Errors` instance.

      This is a onvenience method to avoid repeated `reject(..)` calls for merging an `Errors` instance into another `Errors` instance.

      Note that the passed-in `Errors` instance is supposed to refer to the same target object, or at least contain compatible errors that apply to the target object of this `Errors` instance.

      Parameters:
        `errors` - the `Errors` instance to merge in

    - #### hasErrors

          boolean hasErrors()

      Return if there were any errors.

    - #### getErrorCount

          int getErrorCount()

      Return the total number of errors.

    - #### getAllErrors

          List<ObjectError> getAllErrors()

      Get all errors, both global and field ones.
      Returns:
        List of `ObjectError` instances

    - #### hasGlobalErrors

          boolean hasGlobalErrors()

      Are there any global errors?
      Returns:
        `true` if there are any global errors
      See Also:
        `hasFieldErrors()`

    - #### getGlobalErrorCount

          int getGlobalErrorCount()

      Return the number of global errors.
      Returns:
        the number of global errors
      See Also:
        `getFieldErrorCount()`

    - #### getGlobalErrors

          List<ObjectError> getGlobalErrors()

      Get all global errors.
      Returns:
        List of ObjectError instances

    - #### getGlobalError

          ObjectError getGlobalError()

      Get the first global error, if any.
      Returns:
        the global error, or `null`

    - #### hasFieldErrors

          boolean hasFieldErrors()

      Are there any field errors?
      Returns:
        `true` if there are any errors associated with a field
      See Also:
        `hasGlobalErrors()`

    - #### getFieldErrorCount

          int getFieldErrorCount()

      Return the number of errors associated with a field.
      Returns:
        the number of errors associated with a field
      See Also:
        `getGlobalErrorCount()`

    - #### getFieldErrors

          List<FieldError> getFieldErrors()

      Get all errors associated with a field.
      Returns:
        a List of `FieldError` instances

    - #### getFieldError

          FieldError getFieldError()

      Get the first error associated with a field, if any.
      Returns:
        the field-specific error, or `null`

    - #### hasFieldErrors

          boolean hasFieldErrors(String field)

      Are there any errors associated with the given field?
      Parameters:
        `field` - the field name
      Returns:
        `true` if there were any errors associated with the given field

    - #### getFieldErrorCount

          int getFieldErrorCount(String field)

      Return the number of errors associated with the given field.
      Parameters:
        `field` - the field name
      Returns:
        the number of errors associated with the given field

    - #### getFieldErrors

          List<FieldError> getFieldErrors(String field)

      Get all errors associated with the given field.

      Implementations should support not only full field names like "name" but also pattern matches like "na*" or "address.*".

      Parameters:
        `field` - the field name
      Returns:
        a List of `FieldError` instances

    - #### getFieldError

          FieldError getFieldError(String field)

      Get the first error associated with the given field, if any.
      Parameters:
        `field` - the field name
      Returns:
        the field-specific error, or `null`

    - #### getFieldValue

          Object getFieldValue(String field)

      Return the current value of the given field, either the current bean property value or a rejected update from the last binding.

      Allows for convenient access to user-specified field values, even if there were type mismatches.

      Parameters:
        `field` - the field name
      Returns:
        the current value of the given field

    - #### getFieldType

          Class<?> getFieldType(String field)

      Return the type of a given field.

      Implementations should be able to determine the type even when the field value is `null`, for example from some associated descriptor.

      Parameters:
        `field` - the field name
      Returns:
        the type of the field, or `null` if not determinable